package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Integer number manipulations.
 */
public class _3_Number {


    /**
     * Compute a new number from a given positive one by adding a value of one to each of its digits.
     * The »9« digit will be replaced by a »10« (no carry over, just shifting neighbouring digits around).
     *
     * Examples:
     * <ul>
     *     <li>123 becomes 234</li>
     *     <li>91293 becomes 1023104</li>
     * </ul>
     *
     * @param n The input to be enlarged digit wise.
     * @return The raised value.
     *
     * <section class="implementationHints">
     *    <h4 class="implementationHints">Possible implementation idea (»brute force« wise):</h4>
     *    <ol>
     *        <li>Transform the given value into a {@link String} i.e. an <code>int</code> 1234 becomes
     *        <code>"1234"</code>.</li>
     *        <li>Iterate over all digits applying the given substitution rules.</li>
     *        <li>Turn the resulting {@link String} back into an <code>int</code>.</li>
     *    </ol>
     * </section>
     */
    static public int raiseDigitsByOne(int n) {
        // See https://www.reddit.com/r/dailyprogrammer/comments/aphavc/20190211_challenge_375_easy_print_a_new_number_by
        // for a more sophisticated solution.

        // Using simple String instances is easier but (even) less elegant.

        final StringBuffer nString = new StringBuffer(Integer.toString(n));

        for (int i = 0; i < nString.length(); i++) {
            char c = nString.charAt(i);
            if (c < '9') {
                c++;
                nString.setCharAt(i, c);
            } else {
                nString.setCharAt(i, '1');
                nString.insert(++i, '0');
            }
        }
        return Integer.valueOf(nString.toString());
    }

    private _3_Number(){/* Ignore me: Suppressing default constructor javadoc generation:
                                    javadoc does not include private constructors by default */}
}
